/*********************** 
	print_addr.c

		2013.09.06
		By H.Nakano
		version 0.1
***********************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <errno.h>

#include "bmerge.h"

/* after sorted */
int check_dup(ipaddr_range_t *x,int size){
	int		  len = sizeof(ipaddr_range_t);
	int		  flag,hh = 0;
	uint32_t pp = 0;
	int		  rr = -1;
	for(int i=size -1;i >= 0;i--){
		flag = 0;
		if (x[i].num == pp ){
			if ( x[i].range <= rr)
				flag = 1;
			else if ( x[i].range > rr){
				flag = 1;
				x[i+1].range = x[i].range;
			 }
		 }

		if(flag == 1){
			memmove((void *)&x[i], (void *)&x[i+1],(size -1 -i -hh)*len);
			hh ++;
		 } else {
			pp = x[i].num;
			rr = x[i].range;
		 }
	 }
	return size - hh;
}

/* read_file.c */
uint32_t medi2(uint32_t x,uint32_t y,uint32_t z){
    if (x < y){
        if (y < z) 
			return y; 
		 else if (z < x) 
			return x; 
		 else 
			return z; 
	} else {
       if (z < y) 
			return y; 
		else if (x < z) 
			return x; 
		else return z;
    }
}

void qsort2(ipaddr_range_t *a,int left,int right){
	int len = sizeof(ipaddr_range_t); 

	if (left < right) {
		int i = left;
		int j = right;
       ipaddr_range_t tmp;
		uint32_t pivot = medi2(a[i].num, a[i + (j - i) / 2].num, a[j].num); 

       while (1) { 
            while (a[i].num < pivot) 
				i++; 
            while (pivot < a[j].num) 
				j--; 
            if (i >= j) 
				break;

 			memcpy((void *)&tmp, (void *)&a[i],len);
    		memcpy((void *)&a[i],(void *)&a[j],len);
    		memcpy((void *)&a[j],(void *)&tmp,len);
           i++; j--;
          }
        qsort2(a, left, i - 1);  
        qsort2(a, j + 1, right);
    }
}

int medi1(int x,int y,int z)
{
    if (x < y){
        if (y < z) 
			return y; 
		 else if (z < x) 
			return x; 
		 else 
			return z; 
	} else {
       if (z < y) 
			return y; 
		else if (x < z) 
			return x; 
		else return z;
    }
}
void qsort1(int *a,int left,int right){
	if (left < right) {
		int i = left;
		int j = right;
       int tmp;
		int pivot = medi1(a[i], a[i + (j - i) / 2], a[j]); 

       while (1) { 
            while (a[i] < pivot) 
				i++; 
            while (pivot < a[j]) 
				j--; 
            if (i >= j) 
				break;
            tmp = a[i]; 
			 a[i] = a[j]; 
			 a[j] = tmp; 
            i++; j--;
          }
        qsort1(a, left, i - 1);  
        qsort1(a, j + 1, right);
    }
}

int save_datalist(int size,int top,int *data,char *filename){
	errno = 0;
	FILE *fp = fopen(filename,"w");
   if (fp == NULL){
		fprintf(stderr,"Error: open %s (%s)\n",filename,strerror(errno));
		return -1;
	}

	/* sort */
	qsort1(data,0,size -1);
	char val[16];
	for(int i=0;i< size;i++){
		sprintf(val,"%d.%d.%d",(data[i] >> 16) & 0x000000ff,(data[i] >> 8) & 0x000000ff,data[i] & 0x000000ff);
		fprintf(fp,"%8d: %d.%s\n",i + 1,top,val);
	 }
 	fclose(fp);
	return size;
}

int save_sum(int size,int *data,char * filename){
	errno = 0;
	FILE *fp = fopen(filename,"w");
   if (fp == NULL){
		fprintf(stderr,"Error: open %s (%s)\n",filename,strerror(errno));
		return -1;
    }
	int ret = 0;

	for(int i=0;i < size;i++){
		if (data[i] >= 1){
			fprintf(fp,"%4d = %8d\n",i,data[i]); 
		//	printf("%4d = %8d\n",i,data[i]); 
			ret += data[i];
		}
 	 }
	fprintf(fp,"Total  %8d\n",ret);
	fclose(fp);
//	printf("Total  %8d\n",ret);
	return 0;
}

