/************************
	read_file.c
		2013.8.18
		By H.Nakano
*************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <ctype.h>
// #include <errno.h>

#include "bmerge.h"

/* print_addr.c */
extern int  check_dup(ipaddr_range_t *x,int size);
extern void qsort2(ipaddr_range_t *x,uint32_t left,uint32_t right);
/* addr_tools.c */
extern int addr2num(char *addr,uint32_t *val,int *range);

int check_ipaddr_range(char *addr,ipaddr_range_t *rr){
	uint32_t val;
	int      range;

	if ( addr2num(addr,&val,&range) < 0)
		return -1;
//	printf("val:%u:%d\n",val,range);
	rr->num = val;
	rr->range = range;
	return 0;
}

/*
static void print_addr(ipaddr_range_t *addr,int size){
	for(int i=0;i < size;i++){
		printf("%d::%d.%d.%d.%d\n",i,addr[i].num >> 24,(addr[i].num >> 16) & 0x00ff,
								 (addr[i].num >> 8) & 0x0000ff,addr[i].num & 0x000000ff);
	} 
}
*/

#define Ipaddr_Size 1024

ipaddr_range_t * read_file(FILE *fp, int *val){
	int size,num =1;
	char line[128];
	ipaddr_range_t *addr;
	char *p;

//	errno = 0;
	addr = (ipaddr_range_t *)malloc(Ipaddr_Size*sizeof(ipaddr_range_t));
	if (addr == NULL){
		fprintf(stderr,"Error:malloc read_file()\n");
		return NULL;
	 }
//	errno = 0;
	size = 0;
	while(fgets(line,128,fp) != NULL) {
		if (size >= Ipaddr_Size*num){
			num ++;
			addr = (ipaddr_range_t *)realloc(addr,Ipaddr_Size*num*sizeof(ipaddr_range_t));
			if (addr == NULL){
				fprintf(stderr,"Error:realloc read_file()\n");
				return NULL;
		    }
		}
		p = line;
		while(isspace(*p)) p++;
		if (p[0] == '#' || strlen(p) < 7 || isdigit(p[0]) == 0) 
		   continue;

		if (check_ipaddr_range(p,&addr[size]) == 0)
			size++;
	}

	if (size <= 0){
		*val = -1;
		free(addr);
		return NULL;
	 }

	addr[size+1].num = 0; 
	qsort2(addr,0,size -1);
 //	printf("size 11: %d\n",size);
	size = check_dup(addr,size);
 //	printf("size 12: %d\n",size);
//	print_addr(addr,size);

	*val = size;
	return addr;
}

